VSphereClusterTemplate [infrastructure.cluster.x-k8s.io/v1beta1]

Description
VSphereClusterTemplate is the Schema for the vsphereclustertemplates API.
Type
object

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject

VSphereClusterTemplateSpec defines the desired state of VSphereClusterTemplate.

.spec

Description
VSphereClusterTemplateSpec defines the desired state of VSphereClusterTemplate.
Type
object
Required
template
PropertyTypeDescription
templateobject

VSphereClusterTemplateResource describes the data for creating a VSphereCluster from a template.

.spec.template

Description
VSphereClusterTemplateResource describes the data for creating a VSphereCluster from a template.
Type
object
Required
spec
PropertyTypeDescription
specobject

VSphereClusterSpec defines the desired state of VSphereCluster.

.spec.template.spec

Description
VSphereClusterSpec defines the desired state of VSphereCluster.
Type
object
PropertyTypeDescription
clusterModulesarray

ClusterModules hosts information regarding the anti-affinity vSphere constructs for each of the objects responsible for creation of VM objects belonging to the cluster.

controlPlaneEndpointobject

ControlPlaneEndpoint represents the endpoint used to communicate with the control plane.

disableClusterModuleboolean

DisableClusterModule is used to explicitly turn off the ClusterModule feature. This should work along side NodeAntiAffinity feature flag. If the NodeAntiAffinity feature flag is turned off, this will be disregarded.

failureDomainSelectorobject

FailureDomainSelector is the label selector to use for failure domain selection for the control plane nodes of the cluster. If not set (nil), selecting failure domains will be disabled. An empty value ({}) selects all existing failure domains. A valid selector will select all failure domains which match the selector.

identityRefobject

IdentityRef is a reference to either a Secret or VSphereClusterIdentity that contains the identity to use when reconciling the cluster.

serverstring

Server is the address of the vSphere endpoint.

thumbprintstring

Thumbprint is the colon-separated SHA-1 checksum of the given vCenter server's host certificate

.spec.template.spec.clusterModules

Description
ClusterModules hosts information regarding the anti-affinity vSphere constructs for each of the objects responsible for creation of VM objects belonging to the cluster.
Type
array

.spec.template.spec.clusterModules[]

Description
ClusterModule holds the anti affinity construct `ClusterModule` identifier in use by the VMs owned by the object referred by the TargetObjectName field.
Type
object
Required
controlPlanemoduleUUIDtargetObjectName
PropertyTypeDescription
controlPlaneboolean

ControlPlane indicates whether the referred object is responsible for control plane nodes. Currently, only the KubeadmControlPlane objects have this flag set to true. Only a single object in the slice can have this value set to true.

moduleUUIDstring

ModuleUUID is the unique identifier of the ClusterModule used by the object.

targetObjectNamestring

TargetObjectName points to the object that uses the Cluster Module information to enforce anti-affinity amongst its descendant VM objects.

.spec.template.spec.controlPlaneEndpoint

Description
ControlPlaneEndpoint represents the endpoint used to communicate with the control plane.
Type
object
Required
hostport
PropertyTypeDescription
hoststring

The hostname on which the API server is serving.

portinteger

The port on which the API server is serving.

.spec.template.spec.failureDomainSelector

Description
FailureDomainSelector is the label selector to use for failure domain selection for the control plane nodes of the cluster. If not set (`nil`), selecting failure domains will be disabled. An empty value (`{}`) selects all existing failure domains. A valid selector will select all failure domains which match the selector.
Type
object
PropertyTypeDescription
matchExpressionsarray

matchExpressions is a list of label selector requirements. The requirements are ANDed.

matchLabelsobject

matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.

.spec.template.spec.failureDomainSelector.matchExpressions

Description
matchExpressions is a list of label selector requirements. The requirements are ANDed.
Type
array

.spec.template.spec.failureDomainSelector.matchExpressions[]

Description
A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
Type
object
Required
keyoperator
PropertyTypeDescription
keystring

key is the label key that the selector applies to.

operatorstring

operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.

valuesarray

values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.

.spec.template.spec.failureDomainSelector.matchExpressions[].values

Description
values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
Type
array

.spec.template.spec.failureDomainSelector.matchExpressions[].values[]

Type
string

.spec.template.spec.failureDomainSelector.matchLabels

Description
matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
Type
object

.spec.template.spec.identityRef

Description
IdentityRef is a reference to either a Secret or VSphereClusterIdentity that contains the identity to use when reconciling the cluster.
Type
object
Required
kindname
PropertyTypeDescription
kindstring

Kind of the identity. Can either be VSphereClusterIdentity or Secret

namestring

Name of the identity.

API Endpoints

The following API endpoints are available:

  • /apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vsphereclustertemplates
    • DELETE: delete collection of VSphereClusterTemplate
    • GET: list objects of kind VSphereClusterTemplate
    • POST: create a new VSphereClusterTemplate
  • /apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vsphereclustertemplates/{name}
    • DELETE: delete the specified VSphereClusterTemplate
    • GET: read the specified VSphereClusterTemplate
    • PATCH: partially update the specified VSphereClusterTemplate
    • PUT: replace the specified VSphereClusterTemplate

/apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vsphereclustertemplates

HTTP method
DELETE
Description
delete collection of VSphereClusterTemplate
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind VSphereClusterTemplate
HTTP responses
HTTP codeResponse body
200 - OKVSphereClusterTemplateList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new VSphereClusterTemplate
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyVSphereClusterTemplate schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKVSphereClusterTemplate schema
201 - CreatedVSphereClusterTemplate schema
202 - AcceptedVSphereClusterTemplate schema
401 - UnauthorizedEmpty

/apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vsphereclustertemplates/{name}

HTTP method
DELETE
Description
delete the specified VSphereClusterTemplate
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified VSphereClusterTemplate
HTTP responses
HTTP codeResponse body
200 - OKVSphereClusterTemplate schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified VSphereClusterTemplate
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKVSphereClusterTemplate schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified VSphereClusterTemplate
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyVSphereClusterTemplate schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKVSphereClusterTemplate schema
201 - CreatedVSphereClusterTemplate schema
401 - UnauthorizedEmpty